//+-----------+
//| V1+V2.mq4 |
//+-----------+                                                         

#property copyright "Bolla 2007"
#property link      "http://www.forex-tsd.com/"

#include <stdlib.mqh>

//inputs esterni
extern string  Name_Expert       = "V1+V2";
extern string  Type_Account      = "standard";
extern double TakeProfitLong     = 55;
extern double TakeProfitShort    = 60;
extern int     DLong             = 45;
extern int     DShort            = 50;
extern int     StopLossLong      = 60;
extern int     StopLossShort     = 65;
extern int     TrailingStopLong  = 5;
extern int     TrailingStopShort = 5;
extern int     Balance           = 10000;
extern double  Pct_Lot           = 10;
extern int     Pips_ShiftL       = 0;
extern int     Pips_ShiftS       = 0;
extern string Indicator          = "";
extern int    H_level            = 70;
extern int    L_level            = 30;
extern double MultiplierL        = 2;
extern double MultiplierS        = 2;
extern int    Slippage           = 3;
extern bool   UseSound           = false;
extern string NameFileSound      = "alert.wav";

//variabili globali
double  InitLots,MaxLot,n_lot;
double  sB=0,sS=0;
int ripL,ripS,c,j,p,myOrderTypeL,myOrderTypeS,TPL,TPS,XL,XS;
double LotsB,LotsS,Long=1000,Short;
double LastB=0,LastS=1000; 


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  return(0);
  }

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
  return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
   {
   if(Bars<1)   {Print("bars less than 1");return(0);}

   double   Price=iClose(NULL,0,0);
   
   sB=0;
   sS=0;
   double LastLotsL=0;
   double LastLotsS=0;
   
   InitLots=MathFloor((MathCeil(AccountBalance()/Balance)/100)*100)/100;
   if (InitLots<0.01) InitLots=0.01;
   LotsB=InitLots;
   LotsS=InitLots;
   n_lot=0;

   TPL=TakeProfitLong;
   TPS=TakeProfitShort;
   XL=DLong;
   XS=DShort;
   
   for(int i=0;i<OrdersTotal();i++) 
      { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderComment()==Name_Expert)   
        { 
        switch(OrderType())
           {
           case OP_BUY:
              sB=1;
              LastB=OrderOpenPrice();
              if (OrderLots()!=LastLotsL) 
               {
               LastLotsL=OrderLots();
               LotsB=LastLotsL*MultiplierL;
               n_lot=n_lot+LotsB;
               TPL=TPL+Pips_ShiftL;
               XL=XL+Pips_ShiftL;
               }
              break;
           case OP_SELL:
              sS=2;
              LastS=OrderOpenPrice();
              if (OrderLots()!=LastLotsS)
               {
               LastLotsS=OrderLots();
               LotsS=MultiplierS*LastLotsS;
               n_lot=n_lot+LotsS;
               TPS=TPS+Pips_ShiftS;
               XS=XS+Pips_ShiftS;
               }
              break;
           }
        }    
      }
   
   MaxLot=MathFloor(AccountEquity()/Pct_Lot)/100;
   if (n_lot>MaxLot) c=1; else c=0;
   
   ripL=1;
   ripS=1;
   if (Type_Account=="mini") MaxLot=50; else MaxLot=100;
   if (LotsB>MaxLot)
      {
      ripL=MathCeil(LotsB/MaxLot);
      LotsB=NormalizeDouble(LotsB/ripL,2);
      if (LotsB>100) return(0);
      } 
   if (LotsS>MaxLot)
      {
      ripS=MathCeil(LotsS/MaxLot);
      LotsS=NormalizeDouble(LotsS/ripS,2);
      if (LotsS>100) return(0);
      }

   if (sB==0) {Long=1000;}
   if (sS==0) {Short=-1000;}

   if ((sB==1)&&(Long>LastB)) Long=LastB;
   if ((sS==2)&&(Short<LastS)) Short=LastS;

   double spread=(Ask-Bid)/Point;
   
   p=0;
   for(int cnt=OrdersTotal();cnt>=0;cnt--)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	     if (OrderSymbol() == Symbol()) 
	        {	
	  	     if (OrderType()==OP_SELL) 
	  	        {			
	  	  	     if (TrailingStopShort>0) 
			         {
				      if (OrderOpenPrice()-Ask>=(TrailingStopShort+DShort)*Point) 
				        {
				        p=1;					
					     if (OrderStopLoss()>(Ask+Point*TrailingStopShort))
					       {
					       while (!IsTradeAllowed()){}			
					       OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStopShort,0,0,CLR_NONE);
	  					    return(0);	  					
	  				       }
	  			        }
			         }
	  	        }
   
	  	     if (OrderType()==OP_BUY)
	  	        {
	  		     if (TrailingStopLong>0) 
	  		       {
			       if (Bid-OrderOpenPrice()>=(TrailingStopLong+DLong)*Point) 
				        {
				        p=1;
					     if (OrderStopLoss()<(Bid-Point*TrailingStopLong)) 
					         {	
						      while (!IsTradeAllowed()){}			   
					         OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStopLong,0,0,CLR_NONE);
                        return(0);
					         }
  				         }
			       }
	  	        }
   	     }
      }

	 myOrderTypeL=2;
	 myOrderTypeS=1;
	  
	  if (Indicator!="")
	     {
	      myOrderTypeL=0;
	      myOrderTypeS=0;
	  if (Indicator=="RSI")
	    {
	        if(iRSI(NULL,Period(),14,PRICE_CLOSE,0)>H_level)
	           myOrderTypeS=1;
	        if(iRSI(NULL,Period(),14,PRICE_CLOSE,0)<L_level)
	           myOrderTypeL=2;
	        
	    }
	  if (Indicator=="MACD")
        {
            if (iMACD(NULL,Period(),14,26,9,PRICE_CLOSE,MODE_MAIN,0)>iMACD(NULL,0,14,26,9,PRICE_CLOSE,MODE_MAIN,1)) 
               myOrderTypeL=2;
            if (iMACD(NULL,Period(),14,26,9,PRICE_CLOSE,MODE_MAIN,0)<iMACD(NULL,0,14,26,9,PRICE_CLOSE,MODE_MAIN,1)) 
               myOrderTypeS=1;
        }
	  if (Indicator=="TURBO")
        {
          if (iCustom(Symbol(),Period(),"Turbo_JRSX",14,MODE_MAIN,0)>  H_level) 
               myOrderTypeS=1;
          if (iCustom(Symbol(),Period(),"Turbo_JRSX",14,MODE_MAIN,0)<  L_level) 
               myOrderTypeL=2;
        }
 	  if (Indicator=="TURBO2")
        {
          if (iCustom(Symbol(),Period(),"Turbo_JVEL",14,MODE_MAIN,0)>  0.10) 
               myOrderTypeS=1;
          if (iCustom(Symbol(),Period(),"Turbo_JVEL",14,MODE_MAIN,0)< -0.10)  
               myOrderTypeL=2;
        }
	  if (Indicator=="STOCH")
	    {
          if(iStochastic(NULL,Period(),5,3,9,MODE_SMA,0,MODE_MAIN,0)>H_level && iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,1)>H_level)
               myOrderTypeS=1;
          if(iStochastic(NULL,Period(),5,3,9,MODE_SMA,0,MODE_MAIN,0)<L_level && iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,1)<L_level)
               myOrderTypeL=2;
	    }
	    }
   

      if ((sB==1)&&(Price<=(LastB-(XL+spread)*Point))&&(c==0))
         {
         for (j=1;j<=ripL;j++)
            {
            OpenBuy();
            }
         return(0);
         }

      if ((sS==2)&&(Price>=(LastS+(XS)*Point))&&(c==0))
         {
         for (j=1;j<=ripS;j++)
            {
            OpenSell();
            }
         return(0);
         }
      
   if ((sB==1)&&(Price>=(Long+TPL*Point))&&(p==0))            {closeAllOrders(0);sB=0;return(0);}
   if ((sS==2)&&(Price<=(Short-(TPS+spread)*Point))&&(p==0)) {closeAllOrders(1);sS=0;return(0);} 
   
   if ((sB==0)&&(c==0)&&(myOrderTypeL==2))  {OpenBuy();sB=1;} 
   if ((sS==0)&&(c==0)&&(myOrderTypeS==1))  {OpenSell();sS=2;} 
      
  return (0);
}//end start


// - - - - - - FUNZIONI - - - - - - -

void OpenBuy()
   { 
   double ldLot, ldTake; 
   string lsComm; 
   ldLot = GetSizeLotB(); 
   ldTake = NormalizeDouble(GetTakeProfitBuy(),Digits); 
   lsComm = GetCommentForOrder();
   while (!IsTradeAllowed()){}
   OrderSend(Symbol(),OP_BUY,ldLot,Ask,Slippage,Ask-StopLossLong*Point,ldTake,lsComm,0,0,CLR_NONE);
   if (UseSound) PlaySound(NameFileSound);
}
 
void OpenSell()
   { 
   double ldLot, ldTake; 
   string lsComm; 
   ldLot = GetSizeLotS(); 
   ldTake = NormalizeDouble(GetTakeProfitSell(),Digits); 
   lsComm = GetCommentForOrder();
   while (!IsTradeAllowed()){}
   OrderSend(Symbol(),OP_SELL,ldLot,Bid,Slippage,Bid+StopLossShort*Point,ldTake,lsComm,0,0,CLR_NONE); 
   if (UseSound) PlaySound(NameFileSound);
}

void closeAllOrders(int type)
   {
   for(int x=OrdersTotal()-1;x>=0;x--)
      {
      OrderSelect(x,SELECT_BY_POS,MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderComment()==Name_Expert && OrderType()==OP_BUY && type==0)
         {
         while (!IsTradeAllowed()){}
         OrderClose(OrderTicket(), OrderLots(),Bid,Slippage,CLR_NONE);
         continue;
         }
      if (OrderSymbol()==Symbol() && OrderComment()==Name_Expert && OrderType()==OP_SELL && type==1)
         {
         while (!IsTradeAllowed()){}
         OrderClose(OrderTicket(), OrderLots(), Ask,Slippage,CLR_NONE);
         continue;
         }
      }
} 

string GetCommentForOrder() {return(Name_Expert);} 
double GetSizeLotB() {return(LotsB);} 
double GetSizeLotS() {return(LotsS);} 
double GetTakeProfitBuy() {return(Ask+TPL*Point);} 
double GetTakeProfitSell() {return(Bid-TPS*Point);} 